﻿using System;
using System.ComponentModel;

namespace CommandDemo
{

    public interface ISimpleModel : INotifyPropertyChanged
    {
        string Greetings
        {
            get;
            set;
        }
    }

    public class SimpleModel : ISimpleModel
    {
        private string greetings;

        public string Greetings
        {
            get
            {
                return greetings;
            }
            set
            {
                if(!String.Equals(value,greetings))
                {
                    greetings = value;
                    OnPropertyChanged("Greetings");
                }

            }
        }

        public SimpleModel()
        {
            Greetings = "Greetings from SimpleModel";
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string prop)
        {
            if(PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
    }
}
